#ifndef RTC_EEPROM_h
#define RTC_EEPROM_h

#include <Arduino.h>
#include <Wire.h>
#include "pins.h"

#define DS3231_ADR  0x68  // I2C-Adresse der RTC
#define AT24C32_ADR 0x57  // I2C-Adresse des EEPROM (bei A0-A2 offen == Default)

struct RTCdata {
  unsigned long year   : 6; // funktioniert bis 2063, danach ;-) statt 2000 einfach 2064 addieren
  unsigned long month  : 4;
  unsigned long day    : 5;
  unsigned long hour   : 5;
  unsigned long minute : 6;
  unsigned long second : 6;
};


void RTC_EEPROM_init(void);
byte getRTCSec(void);
RTCdata getRTC(void);
void printRTC(RTCdata t);
void setRTC(byte YY, byte MM, byte DD, byte hh, byte mm, byte ss);
void setRTC(char *datetime_str);

byte dec2bcd(byte val);
byte bcd2dec(byte val);
unsigned long lbcd2dec(byte val);


void dumpEEPROM(void);
byte writeEEPROMfull(unsigned int adr, unsigned char *buf, int lng);
byte writeEEPROM(unsigned int adr, unsigned char *buf, byte lng);
void readEEPROMfull(unsigned int adr, unsigned char *buf, int lng);
void readEEPROM(unsigned int adr, unsigned char *buf, byte lng);


#endif

